Request

Response

    POST

    exports

    Submit a new export request.

    Resource Information

    Method and URI
    POST
    https://developer.api.autodesk.com/insights/v1/exports
    Required OAuth Scopes
    data:write
    Data Format
    JSON

    Request

    Headers

    Authorization*
    string
    Must be Bearer <token>, where <token> is obtained via a three-legged OAuth flow.
    Accept-Language
    string
    For Excel output, specifies the language used to localize worksheet names. For other output formats this parameter is not currently.
    * Required

    Request

    URI Parameters

    Request

    Body Structure

    teamId
    string
    Identifies the team for which data will be exported. If not specified, the export will include data from all teams managed by the requesting user.
    outputFormat*
    enum:string
    Output format that will be used for files produced by this export. Possible values: CSV, EXCEL, JSON
    reports*
    enum:array
    Reports that can be requested when submitting an export request. Possible values: SUBSCRIPTIONS, USERS, GROUPS, USAGE, USAGE_REPORT
    startDate
    string (date-time)
    If the USAGE export is requested this parameter is required; it is the start date (UTC) from which usage will be exported. Otherwise this parameter is unused.
    endDate
    string (date-time)
    If the USAGE export is requested this parameter is required; it is the end date (UTC) until which usage will be exported. Otherwise this parameter is unused.
    usageReports
    enum:array
    Reports that can be requested when submitting an export for “USAGE_REPORT”. This field is required if USAGE_REPORT export is requested, and does not apply to other export requests. Possible values: USAGE_REPORT_BY_PRODUCT
    filters
    array
    This field is applicable only if USAGE_REPORT export is requested. Refer to Usage-Report for details.
    * Required

    Response

    HTTP Status Code Summary

    200
    OK
    Request succeeded.
    401
    Unauthorized
    The provided bearer token is not valid.
    403
    Forbidden
    The user or service represented by the bearer token does not have permission to perform this operation.
    500
    Internal Server Error
    An unknown error occurred on the server.

    Response

    Body Structure (200)

    id
    string
    Uniquely identifies this export.
    timestamp
    string (date-time)
    Date/time (UTC) at which this export was created.
    teamId
    string
    Unique identifier for the team associated with this export.
    teamName
    string
    Name of the team associated with this export.
    downloads
    array
    If this export has completed, this section provides the location(s) from which the exported data can be downloaded. Some export types produce multiple downloads.
    downloads.downloads[i].type
    enum:string
    Reports that can be requested when submitting an export request. Possible values: SUBSCRIPTIONS, USERS, GROUPS, USAGE, USAGE_REPORT
    downloads.downloads[i].downloadURL
    string
    URL from which the exported data can be downloaded. Note that this URL is transient and will expire after a few minutes.
    status
    enum:string
    SUBMITTED is a transitional/in-progress state, the others are permanent (i.e. a request can go from SUBMITTED to COMPLETED or from SUBMITTED to ERROR, but never from COMPLETED/ERROR to anything else). Possible values: SUBMITTED, COMPLETED, EXPIRED, ERROR
    outputFormat
    enum:string
    Output format that will be used for files produced by this export. Possible values: CSV, EXCEL, JSON
    reports
    array
    The reports that were requested when this export was created.
    usageReports
    enum:array
    Reports that can be requested when submitting an export request for “USAGE_REPORT”. Possible values: USAGE_REPORT_BY_PRODUCT

    Example 1: Access token expired/invalid

    Unauthorized. (401)

    Request

    curl  -X POST \
          'https://developer.api.autodesk.com/insights/v1/exports' \
          -H 'Content-Type: application/json' \
          -H 'Authorization: Bearer eyJhbGciOiJIUzI1N' \
          -d '{
          "outputFormat": "CSV",
          "reports": "SUBSCRIPTIONS"
          }'
    
    Show More

    Response

    {
      "developerMessage": "Access token provided is invalid or expired.",
      "moreInfo": "https://forge.autodesk.com/en/docs/oauth/v2/developers_guide/error_handling/",
      "errorCode": "AUTH-006"
    }
    

    Example 2: Invalid request

    Internal Server Error. (500)

    Request

    curl  -X GET \
          'https://developer.api.autodesk.com/insights/v1/exports' \
          -H 'Content-Type: application/json' \
          -H 'Authorization: Bearer eyJhbGciOiJIUzI1N' \
          -d '{
          "outputFormat": "SomeIncorrectValue",
          "reports": "SUBSCRIPTIONS"
          }'
    
    Show More

    Response

    {
      "title": "Error",
      "detail": "An error occurred while creating the export."
    }
    

    Example 3: Request Export for SUBSCRIPTIONS

    OK (200)

    Request

    curl  -X GET \
          'https://developer.api.autodesk.com/insights/v1/exports' \
          -H 'Content-Type: application/json' \
          -H 'Authorization: Bearer eyJhbGciOiJIUzI1N' \
          -d '{
          "outputFormat": "EXCEL",
          "reports": ["SUBSCRIPTIONS"]
          }'
    
    Show More

    Response

    {
      "id": "064324c4-2fe6-4fe3-91e8-8aacb22b1376",
      "timestamp": "2021-11-03T22:10:56Z",
      "downloads": [],
      "status": "SUBMITTED",
      "outputFormat": "EXCEL",
      "teamId": null,
      "teamName": null,
      "reports": [
          "SUBSCRIPTIONS"
      ]
    }
    
    Show More

    Example 3: Request Export for USAGE_REPORT_BY_PRODUCT without filters

    OK (200)

    Request

    curl  -X GET \
          'https://developer.api.autodesk.com/insights/v1/exports' \
          -H 'Content-Type: application/json' \
          -H 'Authorization: Bearer eyJhbGciOiJIUzI1N' \
          -d '{
          "outputFormat": "EXCEL",
          "reports": ["USAGE_REPORT"],
          "startDate": "2020-09-28T05:41:03.268Z",
          "endDate": "2025-11-04T17:22:01.019Z",
          "usageReports": ["USAGE_REPORT_BY_PRODUCT"]
          }'
    
    Show More

    Response

    {
      "id": "d2594fdf-c5cd-4885-9cd4-b76588252950",
      "timestamp": "2022-12-12T23:48:28Z",
      "downloads": [],
      "status": "SUBMITTED",
      "outputFormat": "EXCEL",
      "teamId": null,
      "teamName": null,
      "reports": [
          "USAGE_REPORT"
      ]
    }
    
    Show More

    Example 3: Request Export for USAGE_REPORT_BY_PRODUCT with filters

    OK (200)

    Request

    curl  -X GET \
          'https://developer.api.autodesk.com/insights/v1/exports' \
          -H 'Content-Type: application/json' \
          -H 'Authorization: Bearer eyJhbGciOiJIUzI1N' \
          -d '{
          "outputFormat": "EXCEL",
          "reports": ["USAGE_REPORT"],
          "startDate": "2020-09-28T05:41:03.268Z",
          "endDate": "2025-11-04T17:22:01.019Z",
          "usageReports": ["USAGE_REPORT_BY_PRODUCT"],
          "filters": {"source":["sus","flex"], "productLineCode":["ACD"]}
          }'
    
    Show More

    Response

    {
      "id": "d2594fdf-c5cd-4885-9cd4-b76588252950",
      "timestamp": "2022-12-12T23:48:28Z",
      "downloads": [],
      "status": "SUBMITTED",
      "outputFormat": "EXCEL",
      "teamId": null,
      "teamName": null,
      "reports": [
          "USAGE_REPORT"
      ]
    }
    
    Show More

    Example

    Bad Request. (400)

    Request

    curl  -X GET \
          'https://developer.api.autodesk.com/insights/v1/exports' \
          -H 'Content-Type: application/json' \
          -H 'Authorization: Bearer eyJhbGciOiJIUzI1N' \
          -d '{
          "outputFormat": "EXCEL",
          "reports": ["SUBSCRIPTIONS"]
          }'
    
    Show More

    Response

    {
      "title": "Bad Request",
      "detail": "When the usage export is requested, startDate and endDate are required."
    }